import * as SERVER from '@minecraft/server';
//import { system } from '@minecraft/server';
import * as UI from '@minecraft/server-ui';

SERVER.world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('vc:error_block', {
        onRandomTick: e => {
            spread(e.block)
        },

        onPlayerDestroy: e => {
            spread(e.block)
        },
        onPlayerInteract: e => {
            const item = e.player.getComponent("equippable").getEquipment("Mainhand");
            const playerInv = e.player.getComponent("inventory").container

            if (item.typeId != 'minecraft:glass_bottle') return;
            e.block.setType('minecraft:air')
            e.player.runCommand('playsound bottle.dragonbreath')
            e.player.runCommand(`particle vc:error ${e.block.location.x} ${e.block.location.y} ${e.block.location.z}`)
            if (item.amount > 1) {
                item.amount -= 1;
                e.player.getComponent("equippable").setEquipment("Mainhand", item)
                playerInv.addItem(new SERVER.ItemStack('vc:dote', 1))
            }
            else {
                e.player.getComponent("equippable").setEquipment("Mainhand", new SERVER.ItemStack('vc:dote', 1))
            }
        }
    });
});

SERVER.world.afterEvents.itemCompleteUse.subscribe((e) => {
    if (e.itemStack.typeId == 'vc:antidote') {
        console.log('test')
        let corruption = Number(e.source.getDynamicProperty('corruption'));
        e.source.setDynamicProperty('corruption', corruption - 1)
        e.source.runCommand('playsound corruption.uncorrupt @a ~~~')
        e.source.runCommand('particle vc:error ~~~')
        setScreen(e.source, corruption - 1)
        corruptedPlayer(e.source)
    }
    if (e.itemStack.typeId == 'vc:dote') {
        let corruption = Number(e.source.getDynamicProperty('corruption'));
        e.source.setDynamicProperty('corruption', corruption + 1)
        e.source.runCommand('playsound corruption.corrupt @a ~~~')
        e.source.runCommand('particle vc:error ~~~')
        setScreen(e.source, corruption + 1)
        corruptedPlayer(e.source)
    }
})
function spread(block) {
    try {
        if (!block.above(1).isAir) block.above(1).setType('error:error_block')
        if (!block.below(1).isAir) block.below(1).setType('error:error_block')
        if (!block.north(1).isAir) block.north(1).setType('error:error_block')
        if (!block.east(1).isAir) block.east(1).setType('error:error_block')
        if (!block.south(1).isAir) block.south(1).setType('error:error_block')
        if (!block.west(1).isAir) block.west(1).setType('error:error_block')
    } catch (error) { }
    block.dimension.getEntities({ location: block.location, maxDistance: 2, }).forEach(dude => {
        if (dude.typeId == 'minecraft:player') corruptPlayer(dude);
        else if (dude.typeId != 'vc:glitch_creature' && dude.typeId != 'minecraft:item') {
            dude.runCommand(`summon vc:glitch_creature ~~~`)
            dude.remove()
        }
        else if (dude.typeId == 'minecraft:item') dude.kill()
    })
}
function corruptPlayer(player) {
    let corruption = Number(player.getDynamicProperty('corruption'));
    if (!corruption || corruption > 10) { corruption = 0; player.setDynamicProperty('corruption', 0) }
    corruption += 1;
    player.setDynamicProperty('corruption', corruption)
    player.runCommand('playsound corruption.corrupt @a ~~~')
    player.runCommand('particle vc:error ~~~')
    setScreen(player, corruption)
    corruptedPlayer(player)
}

SERVER.system.runInterval(() => {
    SERVER.world.getAllPlayers().forEach(dude => { corruptedPlayer(dude) })
    SERVER.world.getDimension("overworld").runCommand(`execute at @e[type=vc:glitch_creature] run particle vc:error ~~~`)
}, 2);
var effects = ['levitation', 'speed', 'slowness', 'jump_boost']
function corruptedPlayer(player) {
    let corruption = Number(player.getDynamicProperty('corruption'));
    if (!corruption) { corruption = 0; player.setDynamicProperty('corruption', 0) }
    var handeler = new SERVER.ItemStack('vc:corruptdar', 1)
    //console.log(corruption)
    const playerInv = player.getComponent("inventory").container
    switch (corruption) {
        case 1:
            handeler.nameTag = 'Uh-Oh it looks like there is a little corruption on you.\nBrew an antidote to clear it off!';
            break;

        case 2:
            player.runCommand(`camerashake add @s 0.05 0.2`)
            handeler.nameTag = 'Careful! Seems like there is some corruption on you.\nBrew an antidote to clear it off!';
            break;

        case 3:
            player.runCommand(`camerashake add @s 0.15 0.2`)
            handeler.nameTag = 'There is §ka§r lot of corruption o§kn§r you! \nBe §kca§rreful or it might §kt§rake over you§kr§r body!\nBre§kw§r an antidote to cle§ka§rr it off!';
            break;

        case 4:
            player.runCommand(`camerashake add @s 0.2 0.1`)
            handeler.nameTag = '§kD§rem§ki§rse §ki§rs i§km§rm§ki§rne§kn§rt, ru§kn§r';
            break;

        case 5:
            player.runCommand(`camerashake add @s 0.5 0.15`)
            player.addEffect(effects[Math.round(Math.random() * 3)], 2)
            handeler.nameTag = '§kyou should be dead by now';
            break;
        case 6:
            player.setDynamicProperty('corruption', 7)
            SERVER.system.runTimeout(() => {
                player.setDynamicProperty('corruption', 8)
                if (allDead()) {
                    makeWatchdogAngry(1)
                }
            }, 80)
            break;
        case 7:
            //player.runCommand(`camerashake add @s 2 0.2 rotational`)
            player.runCommand(`particle vc:error_spawn ~~~`)
            break;
        case 8:
            player.runCommand(`gamemode spectator @s[m=!spectator]`)
            player.runCommand(`particle vc:error ~ ${(player.getHeadLocation().y) - 0.25} ~`)
            player.runCommand(`title @s actionbar Youve been corrupted!${player.isOp() ? ' to reset use §l!rc§r in chat\n*this will not clear the corrupted blocks' : ''}`)
            handeler.nameTag = 'Looks like you have been consumed by the corruption! Better Luck Next time!';
            break;
        default:
            handeler.nameTag = 'Looks like there is no corruption on you! \nYou are in the clear!';
            break;
    }
    playerInv.setItem(35, handeler)
    try { player.setProperty('vc:stage', corruption) } catch (err) { }
}
SERVER.system.afterEvents.scriptEventReceive.subscribe((data) => {
    if (data.id === "error:setLevel") {
        const player = data.sourceEntity;

        SERVER.world.sendMessage(`Set ${data.sourceEntity.nameTag}'s Corruption level to ${Number(data.message)}`);
        player.setDynamicProperty('corruption', Number(data.message))
        setScreen(player, Number(data.message))
    }
})
function makeWatchdogAngry(real) {
    makeWatchdogAngry(real + 1)
}
function allDead() {
    var cp = 0
    SERVER.world.getAllPlayers().forEach(dude => { if (Number(dude.getDynamicProperty('corruption')) >= 6) cp += 1 })
    SERVER.world.sendMessage(`${cp}, ${SERVER.world.getAllPlayers().length}`);
    return (cp >= SERVER.world.getAllPlayers().length)
}
SERVER.world.beforeEvents.chatSend.subscribe((eventData) => {
    const player = eventData.sender;
    if (eventData.message == '!rc') {
        if (!player.isOp) return;
        eventData.cancel = true;
        const form = new UI.MessageFormData()
            .title("Are you sure?")
            .body("This will reset everyone's corruption level and revive all dead players, are you sure you want to do this?\n\n§cNote: This will §lNOT§r§c remove all corrupted blocks")
            .button1("Yes I do!")
            .button2("No I dont!");
        SERVER.system.run(() => {
            console.log('test 1')
            //UI.UIManager.closeAllForms(player)
            form.show(player).then((r) => {
                console.log('test 2')

                if (r.canceled || r.selection == 1) return;
                //console.log('test')
                SERVER.world.getAllPlayers().forEach(dude => {
                    dude.setDynamicProperty('corruption', 0);
                    setScreen(player, 0);
                    dude.runCommand('gamemode d @s[m=spectator]')
                })
            })
        })
    }
});
SERVER.world.afterEvents.entityHurt.subscribe((data) => {
    const creature = data.damageSource.damagingEntity
    if (creature.typeId != 'vc:glitch_creature') return;
    const victim = data.hurtEntity
    if (victim.typeId == 'minecraft:player') return;
    if (data.damage < victim.getComponent('health').currentValue) return;
    victim.runCommand(`summon vc:glitch_creature ~~~`)
    victim.remove()
})
SERVER.world.afterEvents.playerJoin.subscribe((data) => {
    const player = SERVER.world.getEntity(data.playerId)
    setScreen(player)
})
function setScreen(player, corruption) {

    switch (corruption) {
        case 3: player.runCommand(`title @s title §n§c§a§1`); break;
        case 4: player.runCommand(`title @s title §n§c§a§2`); break;
        case 5: player.runCommand(`title @s title §n§c§a§3`); break;
        case 8: player.runCommand(`title @s title §n§c§a§1`); break;
        default: player.runCommand(`title @s title §n§c§a`); break;
    }
}









const playerBeingShown = {};
import('@minecraft/server-ui').then((ui) => {
    var [userBusy, userClosed] = Object.values(ui.FormCancelationReason), formData;
    for (formData of [ui.ActionFormData, ui.MessageFormData, ui.ModalFormData]) {
        const formShow = Object.getOwnPropertyDescriptor(formData.prototype, "show").value;
        Object.defineProperty(formData.prototype, "show", {
            value: function (player, persistent = false, trials = 100) {
                const show = formShow.bind(this, player);
                if (player.id in playerBeingShown) return;
                playerBeingShown[player.id] = true;
                return new Promise(async (resolve) => {
                    let result;
                    do {
                        result = await show();
                        if (!trials-- || persistent && result.cancelationReason === userClosed) return delete playerBeingShown[player.id];
                    }
                    while (result.cancelationReason === userBusy);
                    delete playerBeingShown[player.id];
                    resolve(result);
                })
            }
        })
    }
});
SERVER.world.afterEvents.playerLeave.subscribe(({ playerId }) => delete playerBeingShown[playerId]);